﻿using System;

using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace PictureBoxMouseDownTester
{
    public partial class Form1 : Form
    {
        private Modes _currentMode = Modes.Hours;

        private int _change = 0;

        public enum Modes : int
        {
            Hours,
            Minutes,
            Seconds,
        }
        
        public Form1()
        {
            InitializeComponent();

            // The rate at which the number increments/decrements
            this.timer1.Interval = 250;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            int value = 0;
            
            switch (_currentMode)
            {
                case Modes.Hours:
                    value = int.Parse(this.labelHours.Text);
                    value += _change;
                    if ((value != -1) && (value != 24))
                    {
                        this.labelHours.Text = value.ToString("D2");
                    }
                    else
                    {
                        value = 0;
                        this.labelHours.Text = value.ToString("D2");
                    }
                    break;
                case Modes.Minutes:
                    value = int.Parse(this.labelMinutes.Text);
                    value += _change;
                    if ((value != -1) && (value != 60))
                    {
                        this.labelMinutes.Text = value.ToString("D2");
                    }
                    else
                    {
                        value = 0;
                        this.labelMinutes.Text = value.ToString("D2");
                    }
                    break;
                case Modes.Seconds:
                    value = int.Parse(this.labelSeconds.Text);
                    value += _change;
                    if ((value != -1) && (value != 60))
                    {
                        this.labelSeconds.Text = value.ToString("D2");
                    }
                    else
                    {
                        value = 0;
                        this.labelSeconds.Text = value.ToString("D2");
                    }
                    break;
            }
        }

        private void pictureBoxHoursUp_MouseDown(object sender, MouseEventArgs e)
        {
            _currentMode = Modes.Hours;

            _change = 1;

            this.timer1.Enabled = true;
        }

        private void pictureBoxHoursDown_MouseDown(object sender, MouseEventArgs e)
        {
            _currentMode = Modes.Hours;

            _change = -1;

            this.timer1.Enabled = true;
        }

        private void pictureBoxMinutesUp_MouseDown(object sender, MouseEventArgs e)
        {
            _currentMode = Modes.Minutes;

            _change = 1;

            this.timer1.Enabled = true;
        }

        private void pictureBoxMinutesDown_MouseDown(object sender, MouseEventArgs e)
        {
            _currentMode = Modes.Minutes;

            _change = -1;

            this.timer1.Enabled = true;
        }

        private void pictureBoxSecondsUp_MouseDown(object sender, MouseEventArgs e)
        {
            _currentMode = Modes.Seconds;

            _change = 1;

            this.timer1.Enabled = true;
        }

        private void pictureBoxSecondsDown_MouseDown(object sender, MouseEventArgs e)
        {
            _currentMode = Modes.Seconds;

            _change = -1;

            this.timer1.Enabled = true;
        }

        private void pictureBoxDisable_MouseUp(object sender, MouseEventArgs e)
        {
            this.timer1.Enabled = false;
        }
    }
}